



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python的time（时间戳与时间字符串互相转化）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python的time（时间戳与时间字符串互相转化）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 06:40:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>strptime("string format")字符串如“20130512000000”格式的 输入处理函数</p>
<p>localtime(float a)时间戳的输入处理函数</p>
<p>二者返回struct_time结构数据，</p>
<p>由strftime(format, float/time_struct) 和mktime(struct_time)处理后输出，返回日期格式字符串和秒数。</p>
<p>#设a为字符串</p>
<p>import time</p>
<p>a= "2011-09-28 10:00:00"</p>
<p>对时间处理一般都先转化为struct_time结构，在进行处理，举例如下：</p>
<p>#1中间过程，一般都需要将字符串转化为时间数组</p>
<p>time.strptime(a,'%Y-%m-%d %H:%M:%S')</p>
<p>&gt;&gt;time.struct_time(tm_year=2011, tm_mon=9, tm_mday=27, tm_hour=10, tm_min=50, tm_sec=0, tm_wday=1, tm_yday=270, tm_isdst=-1)</p>
<p>#2将"2011-09-28 10:00:00"转化为时间戳</p>
<p>time.mktime(time.strptime(a,'%Y-%m-%d %H:%M:%S'))</p>
<p>&gt;&gt;1317091800.0</p>
<p>#3将时间戳转化为localtime</p>
<p>x = time.localtime(1317091800.0)#localtime参数为float类型，这里1317091800.0为float类型</p>
<p>time.strftime('%Y-%m-%d %H:%M:%S',x)</p>
<p>&gt;&gt;2011-09-27 10:50:00[/python]</p>
<p>my practice：</p>
<p>定义好格式：</p>
<p>ISFORMAT="%Y-%m-%d %H:%M:%S"<br /><br />
&nbsp;&nbsp;&nbsp; TIMESTAMP="%Y%m%d%H%M%S"<br /><br />
&nbsp;&nbsp;&nbsp; start=1375063206.926#1375099552927<br /><br />
&nbsp;&nbsp;&nbsp; end=1375099591.118</p>
<p>时间戳为总秒数，可以进行算术运算，10位精确到秒，13位精确到毫秒。</p>
<p>测试一下time：<br /><br />
&nbsp;&nbsp;&nbsp; print time.time()<br /><br />
&nbsp;&nbsp;&nbsp; print type(time.ctime())</p>
<p>print time.mktime(time.localtime())#测试时间戳</p>
<p>1，时间戳转化为struct_time<br /><br />
&nbsp;&nbsp;&nbsp; start_t=time.localtime(start)<br /><br />
&nbsp;&nbsp;&nbsp; end_t=time.localtime(end)</p>
<p>2，struct_time转化为指定格式日期字符串<br /><br />
&nbsp;&nbsp;&nbsp; print time.strftime(ISFORMAT,start_t)<br /><br />
&nbsp;&nbsp;&nbsp; print time.strftime(ISFORMAT,end_t)</p>
<p>日期字符串的读取：</p>
<p>tt="201307291008"</p>
<p>print time.strptime(tt,TIMESTAMP)#读入为struct_time<br /><br />
&nbsp;&nbsp;&nbsp; print time.mktime(time.strptime(tt,TIMESTAMP))#变为时间戳</p>
<p>so ,you can find that ：</p>
<p>strptime("string format")&nbsp;and &nbsp;localtime(float a) will both return a struct_time class object</p>
<p>strftime(format, float/time_struct) return a string to display the date of string</p>
<p>mktime(struct_time) will generate a timestamp and return it</p>
<p>自己写的英文自己都不想读了。</p>
<p>再给出一个完成的例子，涉及到时间戳的计算</p>
<p>import sys<br /><br />
import os<br /><br />
import time<br /><br />
import datetime</p>
<p>def readline():<br /><br />
&nbsp;&nbsp;&nbsp; return</p>
<p>if __name__ == '__main__':<br /><br />
&nbsp;##&nbsp;&nbsp;&nbsp; keylist={}#{"name":"value"}<br /><br />
##&nbsp;&nbsp;&nbsp; filecontent= open("g:\\test.txt","r")#file("name.txt","r")<br /><br />
##&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #for line in sys.stdin:<br /><br />
##&nbsp;&nbsp;&nbsp; for line in filecontent.readlines():<br /><br />
##&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; print line<br /><br />
&nbsp;&nbsp;&nbsp; ISFORMAT="%Y-%m-%d %H:%M:%S"<br /><br />
&nbsp;&nbsp;&nbsp; TIMESTAMP="%Y%m%d%H%M%S"<br /><br />
&nbsp;&nbsp;&nbsp; start=1375063206.926#1375099552927<br /><br />
&nbsp;&nbsp;&nbsp; end=1375099591.118<br /><br />
&nbsp;&nbsp;&nbsp; print time.time()<br /><br />
&nbsp;&nbsp;&nbsp; print type(time.ctime())<br /><br />
&nbsp;&nbsp;&nbsp; start_t=time.localtime(start)<br /><br />
&nbsp;&nbsp;&nbsp; end_t=time.localtime(end)<br /><br />
&nbsp;&nbsp;&nbsp; print time.strftime(ISFORMAT,start_t)<br /><br />
&nbsp;&nbsp;&nbsp; print time.strftime(ISFORMAT,end_t)<br /><br />
&nbsp;&nbsp;&nbsp; print "test now:"<br /><br />
&nbsp;&nbsp;&nbsp; tt="20130729100823"<br /><br />
&nbsp;&nbsp;&nbsp; #time.strptime(tt,TIMESTAMP)<br /><br />
&nbsp;&nbsp;&nbsp; print time.mktime(time.strptime(tt,TIMESTAMP))<br /><br />
&nbsp;&nbsp;&nbsp; print time.strftime(ISFORMAT,time.strptime(tt,TIMESTAMP))<br /><br />
&nbsp;&nbsp;&nbsp; #print time.mktime(time.localtime())<br /><br />
&nbsp;&nbsp;&nbsp; testtime="20130729100823"<br /><br />
&nbsp;&nbsp;&nbsp; timeof=time.mktime(time.strptime(testtime,TIMESTAMP))<br /><br />
&nbsp;&nbsp;&nbsp; print type(timeof)<br /><br />
&nbsp;&nbsp;&nbsp; timeof+=3600.000<br /><br />
&nbsp;&nbsp;&nbsp; print timeof<br /><br />
&nbsp;&nbsp;&nbsp; dd = time.localtime(timeof)<br /><br />
&nbsp;&nbsp;&nbsp; print type(dd)<br /><br />
&nbsp;&nbsp;&nbsp; print time.strftime(ISFORMAT,dd)</p>
<p>一、简介</p>
<p>time模块提供各种操作时间的函数<br /><br />
说明：一般有两种表示时间的方式:<br /><br />
第一种是时间戳的方式(相对于1970.1.1 00:00:00以秒计算的偏移量),时间戳是惟一的<br /><br />
第二种以数组的形式表示即(struct_time),共有九个元素，分别表示，同一个时间戳的struct_time会因为时区不同而不同<br /><br />
year (four digits, e.g. 1998)<br /><br />
month (1-12)<br /><br />
day (1-31)<br /><br />
hours (0-23)<br /><br />
minutes (0-59)<br /><br />
seconds (0-59)<br /><br />
weekday (0-6, Monday is 0)<br /><br />
Julian day (day in the year, 1-366)<br /><br />
DST (Daylight Savings Time) flag (-1, 0 or 1) 是否是夏令时<br /><br />
If the DST flag is 0, the time is given in the regular time zone;<br /><br />
if it is 1, the time is given in the DST time zone;<br /><br />
if it is -1, mktime() should guess based on the date and time.<br /><br />
夏令时介绍：http://baike.baidu.com/view/100246.htm<br /><br />
UTC介绍：http://wenda.tianya.cn/wenda/thread?tid=283921a9da7c5aef&amp;clk=wttpcts<br /><br />
<br /><br />
二、函数介绍<br /><br />
1.asctime()<br /><br />
asctime([tuple]) -&gt; string<br /><br />
将一个struct_time(默认为当时时间)，转换成字符串<br /><br />
Convert a time tuple to a string, e.g. 'Sat Jun 06 16:26:11 1998'.<br /><br />
When the time tuple is not present, current time as returned by localtime()<br /><br />
is used.<br /><br />
<br /><br />
2.clock()<br /><br />
clock() -&gt; floating point number<br /><br />
该函数有两个功能，<br /><br />
在第一次调用的时候，返回的是程序运行的实际时间；<br /><br />
以第二次之后的调用，返回的是自第一次调用后,到这次调用的时间间隔<br /><br />
<br /><br />
示例：</p>
<div>
<ol><li>import time</li>
<li>if __name__ == '__main__':</li>
<li>time.sleep(1)</li>
<li>print "clock1:%s" % time.clock()</li>
<li>time.sleep(1)</li>
<li>print "clock2:%s" % time.clock()</li>
<li>time.sleep(1)</li>
<li>print "clock3:%s" % time.clock()</li></ol>
</div>
<p>输出：<br /><br />
clock1:3.35238137808e-006<br /><br />
clock2:1.00004944763<br /><br />
clock3:2.00012040636<br /><br />
其中第一个clock输出的是程序运行时间<br /><br />
第二、三个clock输出的都是与第一个clock的时间间隔<br /><br />
<br /><br />
3.sleep(...)<br /><br />
sleep(seconds)<br /><br />
线程推迟指定的时间运行，经过测试，单位为秒，但是在帮助文档中有以下这样一句话，这关是看不懂<br /><br />
“The argument may be a floating point number for subsecond precision.”<br /><br />
<br /><br />
4.ctime(...)<br /><br />
ctime(seconds) -&gt; string<br /><br />
将一个时间戳(默认为当前时间)转换成一个时间字符串<br /><br />
例如：<br /><br />
time.ctime()<br /><br />
输出为：'Sat Mar 28 22:24:24 2009'<br /><br />
<br /><br />
5.gmtime(...)<br /><br />
gmtime([seconds]) -&gt; (tm_year, tm_mon, tm_day, tm_hour, tm_min,tm_sec, tm_wday, tm_yday, tm_isdst)<br /><br />
将一个时间戳转换成一个UTC时区(0时区)的struct_time，如果seconds参数未输入，则以当前时间为转换标准<br /><br />
<br /><br />
<br /><br />
6.localtime(...)<br /><br />
localtime([seconds]) -&gt; (tm_year,tm_mon,tm_day,tm_hour,tm_min,tm_sec,tm_wday,tm_yday,tm_isdst)<br /><br />
将一个时间戳转换成一个当前时区的struct_time，如果seconds参数未输入，则以当前时间为转换标准<br /><br />
<br /><br />
<br /><br />
7.mktime(...)<br /><br />
mktime(tuple) -&gt; floating point number<br /><br />
将一个以struct_time转换为时间戳<br /><br />
<br /><br />
8.strftime(...)<br /><br />
strftime(format[, tuple]) -&gt; string<br /><br />
将指定的struct_time(默认为当前时间)，根据指定的格式化字符串输出<br /><br />
python中时间日期格式化符号：<br /><br />
%y 两位数的年份表示（00-99）<br /><br />
%Y 四位数的年份表示（000-9999）<br /><br />
%m 月份（01-12）<br /><br />
%d 月内中的一天（0-31）<br /><br />
%H 24小时制小时数（0-23）<br /><br />
%I 12小时制小时数（01-12） <br /><br />
%M 分钟数（00=59）<br /><br />
%S 秒（00-59）<br /><br />
<br /><br />
%a 本地简化星期名称<br /><br />
%A 本地完整星期名称<br /><br />
%b 本地简化的月份名称<br /><br />
%B 本地完整的月份名称<br /><br />
%c 本地相应的日期表示和时间表示<br /><br />
%j 年内的一天（001-366）<br /><br />
%p 本地A.M.或P.M.的等价符<br /><br />
%U 一年中的星期数（00-53）星期天为星期的开始<br /><br />
%w 星期（0-6），星期天为星期的开始<br /><br />
%W 一年中的星期数（00-53）星期一为星期的开始<br /><br />
%x 本地相应的日期表示<br /><br />
%X 本地相应的时间表示<br /><br />
%Z 当前时区的名称<br /><br />
%% %号本身 <br /><br />
<br /><br />
9.strptime(...)<br /><br />
strptime(string, format) -&gt; struct_time<br /><br />
将时间字符串根据指定的格式化符转换成数组形式的时间<br /><br />
例如：<br /><br />
2009-03-20 11:45:39 对应的格式化字符串为：%Y-%m-%d %H:%M:%S<br /><br />
Sat Mar 28 22:24:24 2009 对应的格式化字符串为：%a %b %d %H:%M:%S %Y<br /><br />
<br /><br />
10.time(...)<br /><br />
time() -&gt; floating point number<br /><br />
返回当前时间的时间戳<br /><br />
<br /><br />
三、疑点<br /><br />
1.夏令时<br /><br />
在struct_time中，夏令时好像没有用，例如<br /><br />
a = (2009, 6, 28, 23, 8, 34, 5, 87, 1)<br /><br />
b = (2009, 6, 28, 23, 8, 34, 5, 87, 0)<br /><br />
a和b分别表示的是夏令时和标准时间，它们之间转换为时间戳应该相关3600，但是转换后输出都为646585714.0<br /><br />
<br /><br />
四、小应用<br /><br />
1.python获取当前时间<br /><br />
time.time() 获取当前时间戳<br /><br />
time.localtime() 当前时间的struct_time形式<br /><br />
time.ctime() 当前时间的字符串形式<br /><br />
<br /><br />
2.python格式化字符串 <br /><br />
格式化成2009-03-20 11:45:39形式<br /><br />
time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) <br /><br />
<br /><br />
格式化成Sat Mar 28 22:24:24 2009形式<br /><br />
time.strftime("%a %b %d %H:%M:%S %Y", time.localtime()) <br /><br />
<br /><br />
3.将格式字符串转换为时间戳<br /><br />
a = "Sat Mar 28 22:24:24 2009"<br /><br />
b = time.mktime(time.strptime(a,"%a %b %d %H:%M:%S %Y"))</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495d5kvq.html">httpServletRequest对象、filter、servlet、servlet容器、catalina、tomcat、以及web容器之间的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96zxwvq.html">SAP 应用服务负载均衡的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932rygq.html">Python 基礎 - while流程判斷</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8egzjk9.html">Hibernate映射之OneToOne&lpar;第二篇&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/390wd1nq.html">Memcached 笔记与总结（5）Memcached  的普通哈希分布和一致性哈希分布</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okk2l59.html">js用ajax和jison在不同页面的php和html之间互相传值的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1kn159.html">谈在一个将TXT按章节分割的PHP程序中的收获</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvllnjq.html">SQL语句优化技术分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11ygzq.html">URAL 1141&period; RSA Attack RSA加密演算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pnngj8.html">ORACLE数据库学习之备份与恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv25dvy9.html">Nilearn 小记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1j5yw9.html">SQL求几何重心</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5yx14q.html">zabbix系列~ 监控模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwo0n79.html">VC使一个对话框不显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2rmn19.html">【转载】SpringCloud-Eurek 心跳阈值说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy6nwmq.html">在jsp中应如何避免，request&period;getContextPath&lpar;&rpar;&semi;等get报错问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5mppeq.html">日常工作--IIS修改增加最大数据库连接池</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vzeyzq.html">BEM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmlzpe9.html">java&period;lang&period;String cannot be cast to java&period;util&period;Date</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkd1638.html">BZOJ 3709&amp;amp&semi;&amp;amp&semi;AGC 018 C&mdash;&mdash;多段排序的微扰法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7z12n19.html">About Windows 10 April 2018 Update</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z17259.html">mysql5&period;7在centos上安装的完整教程以及相关的&OpenCurlyDoubleQuote;坑&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m5k748.html">加解密、PKI与CA基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/950173e8.html">OpenCV&plus;VS2013 属性表配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1w72zq.html">OBJ文件格式分析工具&colon; objdump&comma; nm&comma;ar</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j16ro8.html">如何找出Xcode中不同版本Swift的路径</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1wn0zq.html">linux找不到动态链接库 &period;so文件的解决方法&lpar;转自：http&colon;&sol;&sol;www&period;cnblogs&period;com&sol;xudong-bupt&sol;p&sol;3698294&period;html&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rglmv78.html">popupwindow中EditText获取焦点后自动弹出软键盘</a>
			</li>
						<li><a href="https://www.batexi.com/a/9501v108.html">EBS业务学习之库存管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd562d9.html">LeakCanary使用手册</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
